//
// MATLAB Compiler: 4.11 (R2009b)
// Date: Sat Mar 06 04:06:14 2010
// Arguments: "-B" "macro_default" "-W" "cpplib:libmatrix" "-T" "link:lib"
// "AddTwo" "MultiplyTwo" 
//

#include <stdio.h>
#define EXPORTING_libmatrix 1
#include "libmatrix.h"
#ifdef __cplusplus
extern "C" {
#endif

extern mclComponentData __MCC_libmatrix_component_data;

#ifdef __cplusplus
}
#endif


static HMCRINSTANCE _mcr_inst = NULL;


#if defined( _MSC_VER) || defined(__BORLANDC__) || defined(__WATCOMC__) || defined(__LCC__)
#ifdef __LCC__
#undef EXTERN_C
#endif
#include <windows.h>

static char path_to_dll[_MAX_PATH];

BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, void *pv)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
        if (GetModuleFileName(hInstance, path_to_dll, _MAX_PATH) == 0)
            return FALSE;
    }
    else if (dwReason == DLL_PROCESS_DETACH)
    {
    }
    return TRUE;
}
#endif
#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultPrintHandler(const char *s)
{
  return mclWrite(1 /* stdout */, s, sizeof(char)*strlen(s));
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultErrorHandler(const char *s)
{
  int written = 0;
  size_t len = 0;
  len = strlen(s);
  written = mclWrite(2 /* stderr */, s, sizeof(char)*len);
  if (len > 0 && s[ len-1 ] != '\n')
    written += mclWrite(2 /* stderr */, "\n", sizeof(char));
  return written;
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_libmatrix_C_API
#define LIB_libmatrix_C_API /* No special import/export declaration */
#endif

LIB_libmatrix_C_API 
bool MW_CALL_CONV libmatrixInitializeWithHandlers(
    mclOutputHandlerFcn error_handler,
    mclOutputHandlerFcn print_handler)
{
  if (_mcr_inst != NULL)
    return true;
  if (!mclmcrInitialize())
    return false;
  if (!GetModuleFileName(GetModuleHandle("libmatrix"), path_to_dll, _MAX_PATH))
    return false;
  if (!mclInitializeComponentInstanceWithEmbeddedCTF(&_mcr_inst, 
                                                     &__MCC_libmatrix_component_data, 
                                                     true, NoObjectType, LibTarget, 
                                                     error_handler, print_handler, 78041, 
                                                     path_to_dll))
    return false;
  return true;
}

LIB_libmatrix_C_API 
bool MW_CALL_CONV libmatrixInitialize(void)
{
  return libmatrixInitializeWithHandlers(mclDefaultErrorHandler, mclDefaultPrintHandler);
}

LIB_libmatrix_C_API 
void MW_CALL_CONV libmatrixTerminate(void)
{
  if (_mcr_inst != NULL)
    mclTerminateInstance(&_mcr_inst);
}

LIB_libmatrix_C_API 
long MW_CALL_CONV libmatrixGetMcrID() 
{
  return mclGetID(_mcr_inst);
}

LIB_libmatrix_C_API 
void MW_CALL_CONV libmatrixPrintStackTrace(void) 
{
  char** stackTrace;
  int stackDepth = mclGetStackTrace(_mcr_inst, &stackTrace);
  int i;
  for(i=0; i<stackDepth; i++)
  {
    mclWrite(2 /* stderr */, stackTrace[i], sizeof(char)*strlen(stackTrace[i]));
    mclWrite(2 /* stderr */, "\n", sizeof(char)*strlen("\n"));
  }
  mclFreeStackTrace(&stackTrace, stackDepth);
}


LIB_libmatrix_C_API 
bool MW_CALL_CONV mlxAddTwo(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "AddTwo", nlhs, plhs, nrhs, prhs);
}

LIB_libmatrix_C_API 
bool MW_CALL_CONV mlxMultiplyTwo(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
  return mclFeval(_mcr_inst, "MultiplyTwo", nlhs, plhs, nrhs, prhs);
}

LIB_libmatrix_CPP_API 
void MW_CALL_CONV AddTwo(int nargout, mwArray& output, const mwArray& x, const mwArray& y)
{
  mclcppMlfFeval(_mcr_inst, "AddTwo", nargout, 1, 2, &output, &x, &y);
}

LIB_libmatrix_CPP_API 
void MW_CALL_CONV MultiplyTwo(int nargout, mwArray& output, const mwArray& x, const 
                              mwArray& y)
{
  mclcppMlfFeval(_mcr_inst, "MultiplyTwo", nargout, 1, 2, &output, &x, &y);
}
