//
// MATLAB Compiler: 4.11 (R2009b)
// Date: Sat Mar 06 04:06:14 2010
// Arguments: "-B" "macro_default" "-W" "cpplib:libmatrix" "-T" "link:lib"
// "AddTwo" "MultiplyTwo" 
//

#ifndef __libmatrix_h
#define __libmatrix_h 1

#if defined(__cplusplus) && !defined(mclmcrrt_h) && defined(__linux__)
#  pragma implementation "mclmcrrt.h"
#endif
#include "mclmcrrt.h"
#include "mclcppclass.h"
#ifdef __cplusplus
extern "C" {
#endif

#if defined(__SUNPRO_CC)
/* Solaris shared libraries use __global, rather than mapfiles
 * to define the API exported from a shared library. __global is
 * only necessary when building the library -- files including
 * this header file to use the library do not need the __global
 * declaration; hence the EXPORTING_<library> logic.
 */

#ifdef EXPORTING_libmatrix
#define PUBLIC_libmatrix_C_API __global
#else
#define PUBLIC_libmatrix_C_API /* No import statement needed. */
#endif

#define LIB_libmatrix_C_API PUBLIC_libmatrix_C_API

#elif defined(_HPUX_SOURCE)

#ifdef EXPORTING_libmatrix
#define PUBLIC_libmatrix_C_API __declspec(dllexport)
#else
#define PUBLIC_libmatrix_C_API __declspec(dllimport)
#endif

#define LIB_libmatrix_C_API PUBLIC_libmatrix_C_API


#else

#define LIB_libmatrix_C_API

#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_libmatrix_C_API 
#define LIB_libmatrix_C_API /* No special import/export declaration */
#endif

extern LIB_libmatrix_C_API 
bool MW_CALL_CONV libmatrixInitializeWithHandlers(
       mclOutputHandlerFcn error_handler, 
       mclOutputHandlerFcn print_handler);

extern LIB_libmatrix_C_API 
bool MW_CALL_CONV libmatrixInitialize(void);

extern LIB_libmatrix_C_API 
void MW_CALL_CONV libmatrixTerminate(void);



extern LIB_libmatrix_C_API 
void MW_CALL_CONV libmatrixPrintStackTrace(void);

extern LIB_libmatrix_C_API 
bool MW_CALL_CONV mlxAddTwo(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);

extern LIB_libmatrix_C_API 
bool MW_CALL_CONV mlxMultiplyTwo(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[]);

extern LIB_libmatrix_C_API 
long MW_CALL_CONV libmatrixGetMcrID();


#ifdef __cplusplus
}
#endif

#ifdef __cplusplus

/* On Windows, use __declspec to control the exported API */
#if defined(_MSC_VER) || defined(__BORLANDC__)

#ifdef EXPORTING_libmatrix
#define PUBLIC_libmatrix_CPP_API __declspec(dllexport)
#else
#define PUBLIC_libmatrix_CPP_API __declspec(dllimport)
#endif

#define LIB_libmatrix_CPP_API PUBLIC_libmatrix_CPP_API

#else

#if !defined(LIB_libmatrix_CPP_API)
#if defined(LIB_libmatrix_C_API)
#define LIB_libmatrix_CPP_API LIB_libmatrix_C_API
#else
#define LIB_libmatrix_CPP_API /* empty! */ 
#endif
#endif

#endif

extern LIB_libmatrix_CPP_API void MW_CALL_CONV AddTwo(int nargout, mwArray& output, const mwArray& x, const mwArray& y);

extern LIB_libmatrix_CPP_API void MW_CALL_CONV MultiplyTwo(int nargout, mwArray& output, const mwArray& x, const mwArray& y);

#endif
#endif
